create or alter procedure REC_DODAJ_REZERWACJE_Z_ONLINE (
    AREZERWACJAINID integer)
as
declare variable OREZERWACJAID integer;
declare variable OSOBAID integer;
declare variable DATAOD date;
declare variable DATADO date;
declare variable POKOJID integer;
declare variable ASORTID integer;
declare variable POKOJTYPID integer;
declare variable STATUS integer;
declare variable CZYAKTYWNA integer;
declare variable IDATAOD integer;
declare variable IDATADO integer;
declare variable DATASTART date;
declare variable ANAZWISKO varchar(70);
declare variable AIMIONA varchar(70);
declare variable AEMAIL varchar(200);
declare variable ATELEFON varchar(100);
declare variable AADRES varchar(250);
declare variable AMIASTO varchar(100);
declare variable AKODPOCZTOWY varchar(20);
declare variable KODKRAJU varchar(20);
declare variable AEMPLOYEEID integer;
declare variable ILE integer;
declare variable ACENA_STALA integer;
declare variable FIRMAID integer;
declare variable NADCENNIKID integer;
declare variable CENNIKID integer;
declare variable RAZEM numeric(15,2);
declare variable NETTO numeric(15,2);
declare variable STAWKA_VAT varchar(5);
declare variable STAWKA integer;
declare variable OBIEKTID integer;
declare variable ILE2 integer;
begin
  :OREZERWACJAID = gen_id(SEQ_REZERWACJA, 1);
  /*sprawdzenie statusu rezerwacji*/
  select A.OSOBA_ID, A.FIRMA_ID, cast(A.REZERWACJAIN_DATA_OD as date), cast(A.REZERWACJAIN_DATA_DO as date), A.POKOJ_ID,
         A.POKOJTYP_ID, A.ASORT_ID, A.REZERWACJAIN_STATUS, A.REZERWACJAIN_AKTYWNA, A.REZERWACJAIN_NAZWISKO,
         coalesce(A.REZERWACJAIN_IMIONA, ''), A.REZERWACJAIN_EMAIL, A.REZERWACJAIN_TELEFON, A.REZERWACJAIN_FIRMA_ADRES,
         A.REZERWACJAIN_FIRMA_MIASTO, A.REZERWACJAIN_FIRMA_KODPOCZTOWY, A.REZERWACJAIN_KODKRAJU,
         A.REZERWACJAIN_CENA_STALA, A.CENNIK_ID, A.NADCENNIK_ID, A.REZERWACJAIN_RAZEM, A.REZERWACJAIN_STAWKA_VAT,
         A.OBIEKT_ID
  from REZERWACJAIN A
  where A.REZERWACJAIN_ID = :AREZERWACJAINID
  into :OSOBAID, :FIRMAID, :DATAOD, :DATADO, :POKOJID, :POKOJTYPID, :ASORTID, :STATUS, :CZYAKTYWNA, :ANAZWISKO,
       :AIMIONA, :AEMAIL, :ATELEFON, :AADRES, :AMIASTO, :AKODPOCZTOWY, :KODKRAJU, :ACENA_STALA, :CENNIKID, :NADCENNIKID,
       :RAZEM, :STAWKA_VAT, OBIEKTID;

  if ((:CZYAKTYWNA > 0) and
      (cast(:DATADO as date) >= cast('NOW' as date)) and
      (:STATUS <> 6)) then
  begin

    select max(E.EMPLOYEE_ID)
    from EMPLOYEE E
    where upper(E.EMPLOYEE_FULLNAME) like '%ONLINE%'
    into :AEMPLOYEEID;

    if ((:AEMPLOYEEID is null) or (:AEMPLOYEEID <= 0)) then
      select E.EMPLOYEE_ID
      from EMPLOG E
      where E.EMPLOG_ID = (select max(A.EMPLOG_ID)
                           from EMPLOG A)
      into :AEMPLOYEEID;

    if ((:OSOBAID is null) or (:OSOBAID <= 0)) then
      select A.OSOBA_ID
      from OSOBA A
      where A.OSOBA_NAZWISKO = :ANAZWISKO and
            A.OSOBA_IMIONA = :AIMIONA and
            A.OSOBA_EMAIL = :AEMAIL
      into :OSOBAID;

    if ((:OSOBAID is null) or (:OSOBAID <= 0)) then
      select OOSOBAID
      from OS_DODAJ_OSOBE(:AIMIONA, :ANAZWISKO, :AEMAIL, :ATELEFON, :AADRES, :AMIASTO, :AKODPOCZTOWY, :KODKRAJU, :AEMPLOYEEID)
      into :OSOBAID;

    if ((:POKOJID is null) or (:POKOJID < 1)) then
      select max(POKOJ_ID) POKOJ_ID
      from REC_WOLNE_POKOJE(:DATAOD, :DATADO, :OBIEKTID, :POKOJTYPID)
      into :POKOJID;

    if ((:POKOJID is null) or (:POKOJID < 1)) then
      select max(POKOJ_ID) POKOJ_ID
      from REC_WOLNE_POKOJE(:DATAOD, :DATADO, :OBIEKTID, -1)
      into :POKOJID;

    if ((:POKOJID > 0) and
        (not(:POKOJID is null))) then
    begin

      /*dodanie rezerwacji*/
      insert into REZERWACJA (REZERWACJA_ID, REZERWACJA_KOD_SYSTEMU, REZERWACJA_START_ID, REZERWACJA_NR,
                              REZERWACJA_NR_ZEWN, REZERWACJA_AKTYWNA, REZERWACJA_STATUS, REZERWACJA_POTWIERDZONA,
                              REZERWACJA_ZABLOKOWANA, REZERWACJA_CALYPOKOJ, REZERWACJA_STATUSPOBYTU,
                              REZERWACJA_POKOJ_STATUS, REZERWACJA_CZY_RATY, REZERWACJA_CZY_DOFNS, REZERWACJA_CZY_VIP,
                              REZERWACJA_CZY_ONLINECHECKIN, REZERWACJA_SEND_MOBILE, REZERWACJA_SYNCHRONIZACJA,
                              REZERWACJA_NAZWISKO, OSOBA_ID, FIRMA_ID, GRUPA_ID, MARKET_ID, SOURCE_ID, RESCANAL_ID,
                              BIURO_ID, ALLOTMENT_ID, KONTYNGENT_ID, TURNUS_ID, TOWARZYSTWO_ID, PROFILIMPORT_ID,
                              OSOBAKARTA_ID, TURA_ID, OBIEKT_ID, POKOJ_ID, POKOJTYP_ID, REZERWACJA_POKOJTYP_ID,
                              POKTYPGRUPA_ID, ASORT_ID, PAKIET_ASORT_ID, PAKIET_CENNIK_ID, REZERWACJA_DATA_ZGLOSZ,
                              REZERWACJA_DATA_OD, REZERWACJA_DATA_DO, REZERWACJA_GODZ_OD, REZERWACJA_GODZ_DO,
                              REZERWACJA_GODZ_PRZYJ, CARRIER_ID, REZERWACJA_PRZYBYCIE_TYP, REZERWACJA_LOT_NR,
                              REZERWACJA_ILE_DOROSLYCH, REZERWACJA_ILE_DZIECI, REZERWACJA_ILE_DODATK,
                              REZERWACJA_DZIECKO_WIEK, REZERWACJA_DZIECKO2_WIEK, REZERWACJA_DZIECKO3_WIEK,
                              REZERWACJA_DOD_WIEK, REZERWACJA_DOD2_WIEK, REZERWACJA_DOD3_WIEK,
                              REZERWACJA_USLUG_KONTRAKT, CENNIK_ID, NADCENNIK_ID, UMOWA_ID, REZERWACJA_CENA,
                              REZERWACJA_CENA_EUR, REZERWACJA_CENA_ZAK, REZERWACJA_CENA_KU, REZERWACJA_STAWKA_VAT,
                              REZERWACJA_PROC_RABATU, REZERWACJA_RABAT, REZERWACJA_RABAT_EUR, REZERWACJA_RAZEM,
                              REZERWACJA_RAZEM_EUR, REZERWACJA_RAZEM_POBYT, REZERWACJA_ZALICZKA,
                              REZERWACJA_ZALICZKA_EUR, REZERWACJA_MIN_ZALICZKA, REZERWACJA_MIN_ZALICZKA_EUR,
                              REZERWACJA_ZAPLACONO, REZERWACJA_ZAPLACONO_EUR, REZERWACJA_WART_PROW,
                              REZERWACJA_CENA_NA_OSOBE, REZERWACJA_CENA_STALA, REZERWACJA_CENA_STATUS,
                              REZERWACJA_USLUGI_INDYWID, REZERWACJA_PRZYJMUJACY_ID, REZERWACJA_ANULOWAL_ID,
                              REZERWACJA_ZAMELDOWAL_ID, REZERWACJA_FORPLA, REZERWACJA_DATA_PLATN,
                              REZERWACJA_PRZETERM_DATA, REZERWACJA_PRZETERM_DATAB, REZERWACJA_PRZETERM_DATAO,
                              REZERWACJA_DATA_KARTY, REZERWACJA_RODZ_KARTY_ID, REZERWACJA_NUMER_KARTY, MAIL_ID,
                              REZERWACJA_KOLOR, REZERWACJA_UWAGI, REZERWACJA_UWAGI2, REZERWACJA_UWAGI3,
                              REZERWACJA_POWOD, REZERWACJA_DATA_ANUL, REZERWACJA_DATA_MOD, ZYWMODEL_ID, POKTYPOPCJA_ID,
                              REZERWACJA_ZYWIENIE_STATUS, REZERWACJA_WSAD, REZERWACJA_VOUCHER,
                              REZERWACJA_VOUCHER_STATUS, REZERWACJA_NUMER_KUPONU, REZERWACJA_KODZ,
                              REZERWACJA_STATUS_DRUKU, REZERWACJA_REGULA_A_ID, REZERWACJA_ANULACJA_TYP,
                              REZERWACJA_STATUS_DRUKUV, RAPBANK_ID, REZERWACJA_GODZ_ZGLOSZ, REZERWACJA_CZY_FAKTURA,
                              REZERWACJA_STATUS_PROMO, REZERWACJA_ZYWIENIE_DIETA, REZERWACJA_WART_ZAK,
                              REZERWACJA_CZY_NPSPRWN, REZERWACJA_DATAD_ANUL, REZERWACJA_REJ_SAM, REZERWACJA_OBIEKT_ID,
                              PAKIET_PRZEZNACZENIE, REZERWACJA_CZY_TFG, REZERWACJA_UWAGI_H, REZERWACJA_DATA_UMOWY,
                              REZERWACJA_USED, ZMIANA_ID, SESSION_ID, SUBSESSION_ID)
      select :OREZERWACJAID, A.REZERWACJAIN_KOD_SYSTEMU, -1, :OREZERWACJAID, A.REZERWACJAIN_NR_ZEWN, 1, 1, 17,
             coalesce(A.REZERWACJAIN_ZABLOKOWANA, 0), coalesce(A.REZERWACJAIN_CALYPOKOJ, 1), 0, 0, 0, 0, 0, 0, 0, 0,
             A.REZERWACJAIN_NAZWISKO || ' ' || coalesce(A.REZERWACJAIN_IMIONA, ''), A.OSOBA_ID, A.FIRMA_ID, A.GRUPA_ID,
             A.MARKET_ID, A.SOURCE_ID, A.RESCANAL_ID, A.BIURO_ID, null, null, null, null, A.PROFILIMPORT_ID, null, null,
             A.OBIEKT_ID, :POKOJID, A.POKOJTYP_ID, A.POKOJTYP_ID, null, A.ASORT_ID, A.PAKIET_ASORT_ID,
             A.PAKIET_CENNIK_ID, 'NOW', A.REZERWACJAIN_DATA_OD, A.REZERWACJAIN_DATA_DO, A.REZERWACJAIN_GODZ_OD,
             A.REZERWACJAIN_GODZ_DO, A.REZERWACJAIN_GODZ_PRZYJ, null, null, null, A.REZERWACJAIN_ILE_DOROSLYCH,
             A.REZERWACJAIN_ILE_DZIECI, A.REZERWACJAIN_ILE_DODATK, A.REZERWACJAIN_DZIECKO_WIEK,
             A.REZERWACJAIN_DZIECKO2_WIEK, A.REZERWACJAIN_DZIECKO3_WIEK, A.REZERWACJAIN_DOD_WIEK,
             A.REZERWACJAIN_DOD2_WIEK, A.REZERWACJAIN_DOD3_WIEK, null, A.CENNIK_ID, A.NADCENNIK_ID, null,
             A.REZERWACJAIN_CENA, A.REZERWACJAIN_CENA_EUR, A.REZERWACJAIN_CENA, A.REZERWACJAIN_CENA,
             A.REZERWACJAIN_STAWKA_VAT, A.REZERWACJAIN_PROC_RABATU, 0, 0, A.REZERWACJAIN_RAZEM,
             A.REZERWACJAIN_RAZEM_EUR, A.REZERWACJAIN_RAZEM, A.REZERWACJAIN_ZALICZKA, A.REZERWACJAIN_ZALICZKA_EUR, 0, 0,
             0, 0, 0, A.REZERWACJAIN_CENA_NA_OSOBE, A.REZERWACJAIN_CENA_STALA, coalesce(A.REZERWACJAIN_CENA_STATUS, 0),
             coalesce(A.REZERWACJAIN_USLUGI_INDYWID, 0), :AEMPLOYEEID, null, null, A.REZERWACJAIN_FORPLA,
             A.REZERWACJAIN_DATA_PLATN, A.REZERWACJAIN_PRZETERM_DATA, A.REZERWACJAIN_PRZETERM_DATAB,
             A.REZERWACJAIN_PRZETERM_DATAO, A.REZERWACJAIN_DATA_KARTY, A.REZERWACJAIN_RODZ_KARTY_ID,
             A.REZERWACJAIN_NUMER_KARTY, null, A.REZERWACJAIN_KOLOR,
             substring('Razem' || cast(cast(:RAZEM as int) as varchar(20)) || ' PLN ' || coalesce(A.REZERWACJAIN_UWAGI, '') from 1 for 200),
             substring(A.REZERWACJAIN_UWAGI2 from 1 for 200), substring(A.REZERWACJAIN_UWAGI3 from 1 for 200), null,
             null, 'NOW', null, null, null, null, A.REZERWACJAIN_VOUCHER, 0, null, null, 0, null, null, null, null,
             A.REZERWACJAIN_GODZ_ZGLOSZ, 0, 0, 0, null, 0, null, null, A.OBIEKT_ID, 0, 0, null, null, 0, A.ZMIANA_ID,
             A.SESSION_ID, 0
      from REZERWACJAIN A
      where A.REZERWACJAIN_ID = :AREZERWACJAINID;

      /*cenniki*/
      insert into REZERWACJACENNIK (REZERWACJACENNIK_ID, REZERWACJA_ID, CENNIK_ID, REZERWACJACENNIK_CENA,
                                    REZERWACJACENNIK_CENA_EUR, REZERWACJACENNIK_VAT, REZERWACJACENNIK_RABAT, DATA_OD,
                                    DATA_DO, REZERWACJACENNIK_STATUS, ZMIANA_ID, EMPLOYEE_ID, REZERWACJACENNIK_USED,
                                    NADCENNIK_ID, REZERWACJACENNIK_DOROSLY)
      select gen_id(SEQ_REZERWACJACENNIK, 1), :OREZERWACJAID, CENNIK_ID, REZERWACJAINCENNIK_CENA,
             REZERWACJAINCENNIK_CENA_EUR, REZERWACJAINCENNIK_VAT, REZERWACJAINCENNIK_RABAT, DATA_OD, DATA_DO,
             REZERWACJAINCENNIK_STATUS, ZMIANA_ID, EMPLOYEE_ID, REZERWACJAINCENNIK_USED, NADCENNIK_ID,
             REZERWACJAINCENNIK_DOROSLY
      from REZERWACJAINCENNIK
      where REZERWACJAIN_ID = :AREZERWACJAINID;

      /*uslugi*/
      update USLUGA U
      set U.REZERWACJA_ID = :OREZERWACJAID
      where U.REZERWACJAIN_ID = :AREZERWACJAINID and
            (U.USLUGA_ANULOWANA = 0 or U.USLUGA_ANULOWANA is null);

      select count(REZERWACJACENNIK_ID)
      from REZERWACJACENNIK
      where REZERWACJA_ID = :OREZERWACJAID
      into :ILE;

      select count(REZERWACJA_ID)
      from USLUGA
      where REZERWACJA_ID = :OREZERWACJAID
      into :ILE2;

      if ((ILE = 0) and
          (ILE2 = 0) and
          (:ACENA_STALA = 0)) then
      begin
        :STAWKA = iif(:STAWKA_VAT <> 'ZW', cast(:STAWKA_VAT as int), 0);
        :NETTO = :RAZEM / (100 + :STAWKA);
        insert into USLUGA (USLUGA_ID, USLUGA_STATUS, USLUGA_ZYWIENIE_STATUS, REZERWACJA_ID, REZERWACJAIN_ID,
                            MELDUNEK_ID, OSOBA_ID, FIRMA_ID, GRUPA_ID, POKOJ_ID, ASORT_ID, ASORT_TYP, USLUGA_ILOSC,
                            NADCENNIK_ID, CENNIK_ID, USLUGA_CENA_JEDN_BRUTTO, USLUGA_KWOTA_NETTO, USLUGA_VAT_SYMBOL,
                            USLUGA_VAT_STAWKA, USLUGA_KWOTA_BRUTTO, USLUGA_KOSZTZAKUPU, USLUGA_DATA, USLUGA_DATA_OD,
                            USLUGA_DATA_DO, USLUGA_UWAGI, USLUGA_USED, USLUGA_STATUS_FISKALNY, USLUGA_INDYWIDUALNA,
                            USLUGA_POCHODZENIE, USLUGA_ZYWIENIE_DIETA, USLUGA_STATUS_RABATU, USLUGA_STATUS_PROMO,
                            USLUGA_STATUS_STANU, ZMIANA_ID, EMPLOYEE_ID, SESSION_ID, USLUGA_CENA_BRUTTO_EUR,
                            USLUGA_KWOTA_NETTO_EUR, USLUGA_KWOTA_BRUTTO_EUR, MELDUNEKOSOBA_ID, REZERWACJAOSOBA_ID,
                            USLUGA_PROC_RABATU, OBIEKT_ID, USLUGA_ANULOWANA)
        values (gen_id(SEQ_USLUGA, 1), 1, 0, :OREZERWACJAID, :AREZERWACJAINID, -1, :OSOBAID, :FIRMAID, null, :POKOJID,
                :ASORTID, 0, 1, :NADCENNIKID, :CENNIKID, :RAZEM, :NETTO, :STAWKA_VAT, :STAWKA, :RAZEM, 0, :DATAOD,
                :DATAOD, :DATAOD, :ANAZWISKO, 0, 0, 0, 0, 0, 0, 0, 0, 0, :AEMPLOYEEID, 0, 0, 0, 0, null, null, 0,
                :OBIEKTID, 0);
        update REZERWACJA R
        set R.REZERWACJA_CENA_STALA = 1,
            R.REZERWACJA_CENA_STATUS = 2
        where R.REZERWACJA_ID = :OREZERWACJAID;
      end

      DATASTART = cast('30-DEC-1899' as date);
      IDATAOD = datediff(day, DATASTART, :DATAOD);
      IDATADO = datediff(day, DATASTART, :DATADO);

      /*oblozenie*/
      begin
        execute procedure DODAJ_OBLOZENIE(cast(IDATAOD as int), cast(IDATADO as int) - 1, :POKOJID, 0, :ASORTID,
            :POKOJTYPID, 1, 0, 1, :OREZERWACJAID, 0, 0, 0, 1, 0);
        execute procedure LOG_SAVE_EVENT('Sprawdzenie rezerwacji online', 'REZERWACJA',
            'REZERWACJA_ID=' || cast(:OREZERWACJAID as varchar(10)), 'REZERWACJA_AKTYWNA', '0', '1', :AEMPLOYEEID);
        when any do
        begin
          update REZERWACJA R
          set R.REZERWACJA_POTWIERDZONA = 0
          where R.REZERWACJA_ID = :OREZERWACJAID;
          execute procedure LOG_SAVE_EVENT('Sprawdzenie rezerwacji online', 'REZERWACJA',
              'REZERWACJA_ID=' || cast(:OREZERWACJAID as varchar(10)), 'REZERWACJA_POTWIERDZONA', '1', '0',
              :AEMPLOYEEID);
        end
      end
      /*aktualizacja statusu rezerwacji in*/
      update REZERWACJAIN A
      set A.REZERWACJA_ID = :OREZERWACJAID,
          A.REZERWACJAIN_STATUS = 6
      where A.REZERWACJAIN_ID = :AREZERWACJAINID;
      execute procedure LOG_SAVE_EVENT('Potwierdzenie rezerwacji online', 'REZERWACJAIN',
          'REZERWACJAIN_ID=' || cast(:AREZERWACJAINID as varchar(10)), 'REZERWACJAIN_STATUS', '0', '6', :AEMPLOYEEID);

    end
    else
    begin
      execute procedure LOG_SAVE_EVENT('Blad rezerwacji online, brak pokoju', 'REZERWACJAIN',
          'REZERWACJAIN_ID=' || cast(:AREZERWACJAINID as varchar(10)), 'REZERWACJAIN_ID',
          cast(:AREZERWACJAINID as varchar(10)), cast(:AREZERWACJAINID as varchar(10)), :AEMPLOYEEID);

      :OREZERWACJAID = -1;
    end
  end
  else
  begin
    execute procedure LOG_SAVE_EVENT('Blad rezerwacji online, nie spelnia kryteriow', 'REZERWACJAIN',
        'REZERWACJAIN_ID=' || cast(:AREZERWACJAINID as varchar(10)), 'REZERWACJAIN_ID',
        cast(:AREZERWACJAINID as varchar(10)), cast(:AREZERWACJAINID as varchar(10)), :AEMPLOYEEID);

    :OREZERWACJAID = -1;
  end
end